window.boot = function () {
    var settings = window._CCSettings;
    window._CCSettings = undefined;

    //add begin -->
    window.titan_cleintVersion = settings.bundleVers.clientVersion;
    window.titan_appPublisher = "QUANMING-XIAOMI";

    //请求
    let httpPost = function(url, callback){
      var xhr = new XMLHttpRequest();
      //xhr.open('POST', url, true);
      xhr.open("GET", url);
      xhr.setRequestHeader("Content-Type", "application/json;charset=utf-8");
      xhr.onreadystatechange = function() {
        if (xhr.readyState == 4) {
          var resp = null;
          try {
            if (xhr.responseText != "") {
              resp = JSON.parse(xhr.responseText);
            }
          }
          catch (e) {
            callback && callback(-1, null, xhr.responseText);
          }
          callback && callback(xhr.status, resp, xhr.responseText);
        }
      }
      xhr.onerror = function (err) {
        callback && callback(-1, null, "Network error");
      };
      xhr.send();
      return xhr;
    }

    //请求 配置文件!
    let cfgUrl = settings.server + "serverCfg.json";
    console.log("requestCfgInfo=" + cfgUrl);
    //add end 

    var onStart = function () {
        cc.view.enableRetina(true);
        cc.view.resizeWithBrowserSize(true);

        var launchScene = settings.launchScene;

        // load scene
        cc.director.loadScene(launchScene, null,
            function () {
                console.log('Success to load scene: ' + launchScene);
            }
        );
    };

    var onLoadCocos = function(){
      var option = {
        id: 'GameCanvas',
        debugMode: settings.debug ? cc.debug.DebugMode.INFO : cc.debug.DebugMode.ERROR,
        showFPS: settings.debug,
        frameRate: 60,
        groupList: settings.groupList,
        collisionMatrix: settings.collisionMatrix,
      }

      cc.assetManager.init({
        bundleVers: settings.bundleVers,
        subpackages: settings.subpackages,
        remoteBundles: settings.remoteBundles,
        server: settings.server,
        subContextRoot: settings.subContextRoot
      });

      var RESOURCES = cc.AssetManager.BuiltinBundleName.RESOURCES;
      var INTERNAL = cc.AssetManager.BuiltinBundleName.INTERNAL;
      var MAIN = cc.AssetManager.BuiltinBundleName.MAIN;
      var START_SCENE = cc.AssetManager.BuiltinBundleName.START_SCENE;
      var bundleRoot = [INTERNAL];

      settings.hasResourcesBundle && bundleRoot.push(RESOURCES);
      settings.hasStartSceneBundle && bundleRoot.push(MAIN);

      var count = 0;
      function cb(err) {
        if (err) return console.error(err.message, err.stack);
        count++;
        if (count === bundleRoot.length + 1) {
          // if there is start-scene bundle. should load start-scene bundle in the last stage
          // Otherwise the main bundle should be the last
          cc.assetManager.loadBundle(settings.hasStartSceneBundle ? START_SCENE : MAIN, function (err) {
            if (!err) cc.game.run(option, onStart);
          });
        }
      }

      // load plugins
      cc.assetManager.loadScript(settings.jsList.map(function (x) { return 'src/' + x; }), cb);

      // load bundles
      for (var i = 0; i < bundleRoot.length; i++) {
        cc.assetManager.loadBundle(bundleRoot[i], cb);
      }
    }

    var requestCfgInfo = function(){
        let url = cfgUrl + "?v=" +(new Date().getTime())
        console.log("requestCfgInfo=" + url);
        httpPost(url, (status, resp, responseText)=>
        {
          console.log("responseText=" + responseText);
          if(resp != null){
            //获取到配置
            console.log("responseObj:"+resp);
            //本地代码版本
            let tmpClientVersion = settings.bundleVers.clientVersion;
            //远程代码版本
            let tmpServerCVersion = resp["clientVersion"];
            //审核代码版本
            let tmpServerSVersion = resp["shenheVersion"];
            //当前资源版本
            let tmpClientResver = resp["clientResver"];
            //当前审核资源版本
            let tmpShenheResver = resp["shenheResver"];
            let bInshenhe = false;
            if(tmpServerCVersion==null || tmpServerSVersion==null){
                requestCfgFail();
                return;
            }

            //是否处于审核模式
            if (tmpServerCVersion!=null && tmpServerSVersion!=null) {
              //本地版本号与审核版本一致，并且版本版本号与线上版本号不一致，说明进入了审核状态
              bInshenhe = tmpClientVersion == tmpServerSVersion && tmpClientVersion != tmpServerCVersion;
              //切换资源目录
              if (bInshenhe) {
                if(tmpShenheResver!=""){
                  settings.bundleVers["resources"] = tmpShenheResver;
                  console.log("switch shenhe ver:"+tmpShenheResver);
                }
                //审核模式: 每次都删除缓存
                var fileSystemManager = qg.getFileSystemManager();
                try {
                  //删除缓存数据
                  console.log("开始删除垃圾文件")
                  fileSystemManager.rmdirSync(qg.env.USER_DATA_PATH + "/gamecaches", true);
                  console.log("删除完成");
                } catch (error) {
                  console.log('error = ' + error);
                }
              }
              else{
                //热更配置
                if(tmpClientVersion == tmpServerCVersion) {
                  if(tmpClientResver!=""){
                    settings.bundleVers["resources"] = tmpClientResver;
                    console.log("switch client ver:"+tmpClientResver);
                  }
                }//版本需要更新，就不要拉最新config了，客户端会报错的
                else{
                  console.log("client needUpdate,dont.t swtich resVer");
                }
              }
              onLoadCocos();
            }
          }
          else{//获取到错误数据
            requestCfgFail();
          }
          
        });
      }

      //请求参数信息
      var requestCfgFail = function(){
        g_RequestCfgCurTimes++;
        if(g_RequestCfgCurTimes < g_RequestCfgMaxTimes){
          requestCfgInfo();
          return;
        }
        console.log("error get setting!");  
        qg.showModal({
          title: '提示',
          content: '请求版本号数据异常，重新请求?',
          success(res) {
            g_RequestCfgCurTimes = 0;
            requestCfgInfo();
          }
        });
      }

      //开始请求必要参数
      var g_RequestCfgMaxTimes = 5;
      var g_RequestCfgCurTimes = 0;
      requestCfgInfo();
};


cc.view._maxPixelRatio = 4; // Release Image objects after uploaded gl texture

cc.macro.CLEANUP_IMAGE_CACHE = true;
window.boot();
